# sample equations to find the roots of
def f(x):
    return (x - 1.0)**2 - 4

class root:
    """ simple class to manage root finding.  All method take in a
        function and desired tolerance """

    def __init__(self, fun, tol):
        self.f = fun
        self.tol = tol


    def bisection(self, xl, xr):
        """ find the root using bisection.  xl and xr should bracket
            the root """

        # initial evaluations
        fl = self.f(xl)
        fr = self.f(xr)
        
        # do we contain a single (odd number actually...) root?
        # (yes if fl and fr have different signs)
        if fl*fr >= 0:
            return None

        err = abs(xr - xl)
        while (err > self.tol):
            xm = 0.5*(xl + xr)
            fm = self.f(xm)

            if fm*fl >= 0:
                # root is in the right half
                xl = xm
                fl = fm

            else:
                # root is in the left half
                xr = xm
                fr = fm

            err = abs(xr - xl)
            print xm

        return 0.5*(xl + xm)

r = root(f, 1.e-6)
print r.bisection(0.0, 10.0)



                
